<?php

// --- FS functions ---

function saveGroups() {
  global $BLXS, $groups_file, $groups;
  $fn = $groups_file;
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  fwrite($fp,'<?'."\n"."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  for ($i=1;$i<count($groups);$i++) {
    fwrite($fp,'$groups['.$i.'] = "'.$groups[$i].'";'."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
    }
  fwrite($fp,"\n".'?'.'>') or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
  }

function saveGroupsMeta() {
  global $BLXS, $groupsmeta_file, $groupsmeta, $groups;
  $fn = $groupsmeta_file;
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  fwrite($fp,'<?'."\n"."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  $cnt = count($groups);
  for ($i=1;$i<=$cnt;$i++) {
    if (!$groupsmeta[$i]) $groupsmeta[$i] = 'false';
    fwrite($fp,'$groupsmeta['.$i.'] = '.$groupsmeta[$i].';'."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
    }
  fwrite($fp,"\n".'?'.'>') or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
  }


  function publishCommgroups() {
  global $BLXS, $groupscomm_file, $groupscomm, $blogs;
  $fn = $groupscomm_file;      
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  fwrite($fp,'<?'."\n"."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  $cnt = count($blogs);
  for ($i=0;$i<$cnt;$i++) {
   if (!$groupscomm[$i]) $groupscomm[$i] = 'false';
    fwrite($fp,'$groupscomm['.$i.'] = '.$groupscomm[$i].';'."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
    }
  fwrite($fp,"\n".'?'.'>') or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
  }

  
function publishArchgroups() {
  global $BLXS, $groupsarch_file, $groupsarch, $blogs;
  $fn = $groupsarch_file;      
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  fwrite($fp,'<?'."\n"."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  $cnt = count($blogs);
  for ($i=0;$i<$cnt;$i++) {
   if (!$groupsarch[$i]) $groupsarch[$i] = 'false';
    fwrite($fp,'$groupsarch['.$i.'] = '.$groupsarch[$i].';'."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
    }
  fwrite($fp,"\n".'?'.'>') or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
  }

function publishDategroups() {
  global $BLXS, $groupsdate_file,$groupsdate, $blogs;
  $fn = $groupsdate_file;      
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  fwrite($fp,'<?'."\n"."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  $cnt = count($blogs);
  for ($i=0;$i<$cnt;$i++)  {
   if (!$groupsdate[$i]) $groupsdate[$i] = 'false';
    fwrite($fp,'$groupsdate['.$i.'] = '.$groupsdate[$i].';'."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
    }
  fwrite($fp,"\n".'?'.'>') or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
  }

  
function loadItemsList() {
  global $items, $items_file;
  $items = array();
  if (file_exists($items_file)) {
    $its = file($items_file);
    for ($i=0;$i<count($its);$i++ ) {
      $it = trim($its[$i]);
      if ($it) {
        $it = explode("\t",$it);
        $items[$it[0]] = $it;
        }
      }
    }
  }
  

function loadSerialsList() {
  global $serials, $serial_items_file, $items;
  $serials = array();
  if (file_exists($serial_items_file)) {
    $its = file($serial_items_file);
    for ($i=0;$i<count($its);$i++ ) {
      $it = trim($its[$i]);
      if ($it) {
        $it = explode("\t",$it);
        $serials[$it[0]] = $it;
        }
      }
    }
    else {
	    $fp = fopen($serial_items_file,'w') or errDie( $BLXS['Err_FileOpen'] . ' (' . $fn . ')');
  reset($items);
  while(list(,$l) = each($items))
    if ($l) {
      fwrite($fp,$l[0]."\t".'0'."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
      }
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')'); 
    }
  }


function saveItemsList() {
  global $BLXS, $items_file, $items;
  rsort($items);
  $fn = $items_file;
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  reset($items);
  while(list(,$l) = each($items))
    if ($l) {
      fwrite($fp,implode("\t",$l)."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
      }
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
  loadItemsList();
  }


function saveSerialsList() {
  global $BLXS, $serials, $serial_items_file;
  rsort($serials);
  $fn = $serial_items_file;
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  reset($serials);
  while(list(,$l) = each($serials))
    if ($l) {
      fwrite($fp,implode("\t",$l)."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
      }
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
  loadSerialsList();
  }


function SaveSerial() {
	 global $BLXS, $serial, $serials_file;
  $fn = $serials_file;
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  fwrite($fp,'<?'."\n\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  
  $sCnt = count($serial);e($sCnt);
  for ($i=1;$i<=$sCnt;$i++) {

	  foreach ($serial[$i] as $key => $val)  {
	  	fwrite($fp,'$serial['.$i.'] ["'.$key.'"] = "'.$val.'";'."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
	  }
	  fwrite($fp,"\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  }
  
  fwrite($fp,'?>') or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
	
	
}
  


function readItem($id) {
  global $path_to_data, $BLXS;
  $fn = $path_to_data.'/'.$id.'.txt';
  if (file_exists($fn)) {
    $arr = file($fn) or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
    return $arr;
    }
  else return false;
  }

function saveItem($id,$grp,$txt,$auth,$mail) {
  global $BLXS, $authID, $path_to_data, $items_file, $items, $replace_macros, $macros;

  // mraveniste add
    if (get_magic_quotes_gpc) $txt = StripSlashes($txt);
  // mraveniste end

  if ($replace_macros && $macros) {
  $txt = preg_replace('/\^([a-zA-Z0-9]+)\^/e','$macros["\\1"]?$macros["\\1"]:"^\\1^"',$txt);
  }
  $fn = $path_to_data.'/'.$id.'.txt';
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  fwrite($fp,$txt) or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
  $items[$id][0] = $id;
  $items[$id][1] = $grp;
  $items[$id][2] = $auth;
  $items[$id][3] = $mail;
  saveItemsList();
  }

function deleteItem($id) {
  global $BLXS, $path_to_data, $items;
  $fn = $path_to_data.'/'.$id.'.txt';
  if (file_exists($fn)) unlink($fn) or errDie($BLXS['Err_FileDelete'] . ' ('.$fn.')');
  $items[$id] = null;
  saveItemsList();
  }

function mkRelDir ($dirAddress) {
global $MakeDirs,$SetGroup,$GroupName,$ChmodNum;
if (!$MakeDirs) return true;
  $splittedAddr = split('/',$dirAddress);
  $spCount = count($splittedAddr)-1;
  
  $mkAddr = $splittedAddr[0].'/';
  $err = false;
  
  for ($i=1;$i<$spCount;$i++) {
    $err = false;
    $mkAddr .= $splittedAddr[$i].'/';

   if (!file_exists($mkAddr)) {
    if (!mkdir($mkAddr)) $err = true;
    chmod($mkAddr,$ChmodNum);
    if ($SetGroup) chgrp($mkAddr,$GroupName);
   }
    
  }
  if(file_exists($mkAddr)) {/*echo 'Adres ji existuje'.'<br/>'; */return true;}
  else return false;
}

function mkRelDirF ($dirAddress) {
global $MakeDirs,$SetGroup,$GroupName,$ChmodNum;
if (!$MakeDirs) return true;
  $splittedAddr = split('/',$dirAddress);
  $spCount = count($splittedAddr);
  
  $mkAddr = $splittedAddr[0].'/';
  $err = false;
  
  for ($i=1;$i<$spCount;$i++) {
    $err = false;
    $mkAddr .= $splittedAddr[$i].'/';
    
   if (!file_exists($mkAddr)) {
    if (!mkdir($mkAddr)) $err = true;
    chmod($mkAddr,$ChmodNum);
    if ($SetGroup) chgrp($mkAddr,$GroupName);
   }
    
  }
  if(file_exists($mkAddr)) {/*echo 'Adres ji existuje'.'<br/>'; */return true;}
  else return false;
}

function saveSpamSettings() {
	 global $BLXS, $spam, $antispam_file;
  $fn = $antispam_file;
  $fp = fopen($fn,'w') or errDie($BLXS['Err_FileOpen'] . ' ('.$fn.')');
  fwrite($fp,'<?'."\n\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  

	  foreach ($spam as $key => $val)  {
	  	fwrite($fp,'$spam["'.$key.'"] = \''.trim($val).'\';'."\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
	  }
	  fwrite($fp,"\n") or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');

  
  fwrite($fp,'?>') or errDie($BLXS['Err_FileWrite'] . ' ('.$fn.')');
  fclose($fp) or errDie($BLXS['Err_FileClose'] . ' ('.$fn.')');
}
?>
